/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Insert temporary data upload to table
*/

CREATE PROCEDURE [dbo].[SP_DLV_Insert_TB_T_DLV_INV_UPLOAD]
   @LP_CD as varchar(4),
   @PO_NO as varchar(11),
   @PO_ITEM_NO as int,
   @ROUTE_CD as varchar(4),
   @REFF_NO as varchar(13),
   @COMP_PRICE_CD as varchar(4),
   @DOC_DT as date,
   @TRANSACTION_QTY as numeric(15,2),
   @LP_INV_NO as varchar(15),
   @PO_DETAIL_PRICE as numeric(15,2),
   @TRANSACTION_CURR as varchar(3),
   @AMOUNT as numeric(15,2),
   @PID as bigint,
   @UserId as varchar(20)
AS
BEGIN
	DECLARE @MODULE_ID as varchar(1) = '3'
	DECLARE @FUNCTION_ID as varchar(5) = '31401'
	DECLARE @na AS VARCHAR(50) = 'SP_DLV_Insert_TB_T_DLV_INV_UPLOAD'
	DECLARE @step AS VARCHAR(50)
	DECLARE @log AS VARCHAR(MAX)
	DECLARE @T AS TABLE (PID BIGINT)
	

	-- 28/04/2014 --
	DECLARE @CHECK_REFF INT, @user_prefix VARCHAR(3), @CHECK_LP_INV INT, @CHECK_EXISTING_INV INT;
	--============--

	--SET @log = 'Please wait a moment';
	--SET @step = @na+'.insert'
	--INSERT @T
	--EXEC dbo.sp_PutLog @log, @UserId, @step, @PID OUTPUT, 'MPCS00002INF', 'INF', @MODULE_ID, @FUNCTION_ID;
	
	DECLARE @LP_NAME varchar(MAX);
	DECLARE @SERVICE_DOC_NO as VARCHAR(MAX);
	SET @SERVICE_DOC_NO = (SELECT DISTINCT SERVICE_DOC_NO FROM TB_R_DLV_GR_IR WHERE REFF_NO = @REFF_NO AND PO_NO = @PO_NO AND PO_ITEM_NO = @PO_ITEM_NO AND CANCEL_STS IS NULL)
	SET @LP_NAME = (SELECT DISTINCT LOG_PARTNER_NAME FROM TB_M_LOGISTIC_PARTNER WHERE LOG_PARTNER_CD = @LP_CD)
	
	BEGIN TRY
		--BEGIN TRAN
			SET @user_prefix = (SELECT SUBSTRING(@UserId, 1, 3));
			
			-- 28/04/2014 --
			SET @CHECK_REFF = (SELECT COUNT (*) FROM TB_R_DLV_SERVICE_DOC WHERE PROCESS_ID IS NULL AND REFF_NO = @REFF_NO )
			
			IF (@CHECK_REFF > 0) BEGIN 
						
					--SET @CHECK_LP_INV = (SELECT COUNT (*) FROM TB_R_DLV_INV_UPLOAD WHERE LP_INV_NO = @LP_INV_NO AND PO_NO = @PO_NO AND PO_ITEM_NO = @PO_ITEM_NO AND COMP_PRICE_CD = @COMP_PRICE_CD AND STATUS_CD NOT IN ('1', '-1', '-3'));
					
					SET @CHECK_EXISTING_INV = (SELECT COUNT (*) FROM  TB_R_DLV_INV_UPLOAD WHERE LP_INV_NO = @LP_INV_NO AND LP_CD=@LP_CD AND STATUS_CD NOT IN ('1', '-1', '-3'));-- AND PROCESS_ID = null);
					
					IF /*(@CHECK_LP_INV = 0) AND */(@user_prefix = @LP_CD) AND (@CHECK_EXISTING_INV = 0) BEGIN
							
							INSERT INTO TB_T_DLV_INV_UPLOAD(SERVICE_DOC_NO, LP_NAME, LP_CD, PO_NO, PO_ITEM_NO, ROUTE_CD, DELIVERY_NO, COMP_PRICE_CD, DOC_DT, QTY, LP_INV_NO, PRICE_AMT, PAYMENT_CURR, PROCESS_ID, REMARKS)
							SELECT @SERVICE_DOC_NO, @LP_NAME, @LP_CD, @PO_NO, @PO_ITEM_NO, @ROUTE_CD, @REFF_NO, @COMP_PRICE_CD, @DOC_DT, @TRANSACTION_QTY, @LP_INV_NO, @PO_DETAIL_PRICE, @TRANSACTION_CURR, @PID, 'Correct'
							
							UPDATE TB_R_DLV_SERVICE_DOC SET PROCESS_ID = @PID WHERE REFF_NO = @REFF_NO;
					END
					ELSE BEGIN
							
							-- COMPARE GR_IR
							INSERT INTO TB_T_DLV_INV_UPLOAD(SERVICE_DOC_NO, LP_NAME, LP_CD, PO_NO, PO_ITEM_NO, ROUTE_CD, DELIVERY_NO, COMP_PRICE_CD, DOC_DT, QTY, LP_INV_NO, PRICE_AMT, PAYMENT_CURR, PROCESS_ID, REMARKS)
							SELECT @SERVICE_DOC_NO, @LP_NAME, @LP_CD, @PO_NO, @PO_ITEM_NO, @ROUTE_CD, @REFF_NO, @COMP_PRICE_CD, @DOC_DT, @TRANSACTION_QTY, @LP_INV_NO, @PO_DETAIL_PRICE, @TRANSACTION_CURR, @PID, 'Incorrect'

					END

			END

			-- 28/04/2014 --

			--INSERT INTO TB_T_DLV_INV_UPLOAD(SERVICE_DOC_NO, LP_NAME, LP_CD, PO_NO, PO_ITEM_NO, ROUTE_CD, DELIVERY_NO, COMP_PRICE_CD, DOC_DT, QTY, LP_INV_NO, PRICE_AMT, PAYMENT_CURR, PROCESS_ID)
			--SELECT @SERVICE_DOC_NO, @LP_NAME, @LP_CD, @PO_NO, @PO_ITEM_NO, @ROUTE_CD, @REFF_NO, @COMP_PRICE_CD, @DOC_DT, @TRANSACTION_QTY, @LP_INV_NO, @AMOUNT, @TRANSACTION_CURR, @PID

			--UPDATE TB_R_DLV_GR_IR SET LIV_FLAG = 1 WHERE REFF_NO = @REFF_NO AND CANCEL_STS IS NULL
			
			--remark by agi
			--SET @log = 'Insert TB_T_DLV_INV_UPLOAD : SERVICE_DOC_NO : '+@SERVICE_DOC_NO+', LP_NAME : '+@LP_NAME+', PO_NO:'+@PO_NO+', PO_ITEM_NO:'+CAST(@PO_ITEM_NO as VARCHAR(MAX))+', ROUTE_CD:'+@ROUTE_CD+', DELIVERY_NO:'+@REFF_NO+', COMP_PRICE_CD:'+@COMP_PRICE_CD;
			SET @log = 'Insert TB_T_DLV_INV_UPLOAD : SERVICE_DOC_NO : '+@SERVICE_DOC_NO+', LP_NAME : '+@LP_NAME+', PO_NO:'+@PO_NO+', PO_ITEM_NO:'+CAST(@PO_ITEM_NO as VARCHAR(MAX))+', ROUTE_CD:'+@ROUTE_CD+', DELIVERY_NO:'+@REFF_NO+', COMP_PRICE_CD:'+@COMP_PRICE_CD+'PID'+cast(@PID as varchar(max));
			SET @step = @na+'.insert'
			INSERT @T
			EXEC dbo.sp_PutLog @log, @UserId, @step, @PID OUTPUT, 'MPCS00004INF', 'INF', @MODULE_ID, @FUNCTION_ID;


		--COMMIT TRAN
	END TRY
	BEGIN CATCH

		--ROLLBACK TRAN
		SET @log = 'Failed to insert into TB_T_DLV_INV_UPLOAD '+ERROR_MESSAGE();
		SET @step = @na+'.insert'
		INSERT @T
		EXEC dbo.sp_PutLog @log, @UserId, @step, @PID OUTPUT, 'MPCS00008ERR', 'ERR', @MODULE_ID, @FUNCTION_ID;
		UPDATE TB_R_DLV_QUEUE SET PROCESS_STATUS = 'QU4' WHERE PROCESS_ID = @PID
		DELETE FROM TB_T_DLV_INV_UPLOAD WHERE PROCESS_ID = @PID
	END CATCH
END

